{$o-,q+,r+}
{$apptype console}

uses math;

const
    maxplen = 400;

type
    transfunc = array[0..maxplen, 1..255] of integer;

var
    i: integer;
    p, t: string;
    hasch: array[1..255] of boolean;
    f: transfunc;

{     }
procedure computefunc(const p: string; var f: transfunc);
var
    i, j, k, m, t1, t2: integer;
begin
    m := length(p);
    for i := 0 to m do begin
        for j := 1 to 255 do if hasch[j] then begin
            k := min(m + 1, i + 2);
            while k > 0 do begin
                dec(k);
                if (k > 0) and (ord(p[k]) = j) then begin
                    t1 := k - 1; t2 := i;
                    while (t1 > 0) and (p[t1] = p[t2]) do begin
                        dec(t1); dec(t2);
                    end;
                    if t1 = 0 then break;
                end;
            end;
            f[i, j] := k;
        end;
    end;
end;

{   }
procedure match(const t: string; var f: transfunc; const m: integer);
var
    n, q, i: integer;
begin
	writeln('   .       q = 0.');
	writeln('   ''a''  ,     f[q, ''a''].');
	writeln;

    n := length(t);
    q := 0;
    for i := 1 to n do begin
	    write('T[', i, '] = ', '''', t[i], ''', f[', q, ', ''', t[i], '''] = ', f[q, ord(t[i])]);
        q := f[q, ord(t[i])];
        if q = m then begin
            write(',     ', m,
                  ',        ', i - m + 1, '.');
        end;
        writeln;
    end;
end;

procedure fill(const n: integer; const ch: char);
var
    i: integer;
begin
    for i := 1 to n do write(ch);
end;

procedure printfunc(var f: transfunc; const m: integer);
var
    i, j, t, digits: integer;
begin
    writeln;
    writeln('  |P| = ', m, ',      - ', m + 1, ' (|P|+1).');    
    writeln('   ,       ', m, '.');
    writeln('   f.    P[0..m],  m = 0..', m, ',');
    writeln('   ''a'',   ,   ');
    writeln('  P[0..m]a,    P.   ');
    writeln('   f[m, ''a'']  .');
    writeln;
    writeln('      :');
    writeln;
    t := m; digits := 0;
    while t > 0 do begin
        inc(digits); t := t div 10;
    end;

    write('  ');
    for i := 0 to m do begin
        write('| ');        
        write(i:digits);
    end;
    writeln;

    for i := 1 to 255 do if hasch[i] then begin        
        write('--');
        for j := 0 to m do begin
            write('+');
            fill(digits + 1, '-');
        end;
        writeln;
        write(' ', chr(i));
        for j := 0 to m do begin
            write('| ');
            write(f[j, i]:digits);
        end;
        writeln;
    end;
    writeln;
end;

begin
    reset(input, 'input.txt');
    rewrite(output, 'output.txt');

    readln(t); readln(p);
    writeln('  "', p, '" (P)   "', t, '" (T).');
    for i := 1 to length(p) do hasch[ord(p[i])] := true;

    computefunc(p, f);
    printfunc(f, length(p));
    match(t, f, length(p));    
end.
